# MySQL-Front 3.2  (Build 10.27)

DROP DATABASE IF EXISTS `workflow`;
CREATE DATABASE `workflow`;

USE `workflow`;

#
# Table structure for table bpelactivity
#

CREATE TABLE `bpelactivity` (
  `ID` int(11) NOT NULL auto_increment,
  `InstanceID` varchar(100) NOT NULL default '',
  `Name` varchar(30) NOT NULL default '',
  `Type` varchar(30) NOT NULL default '',
  `BeginTime` varchar(100) NOT NULL default '',
  `FinishTime` varchar(100) default '',
  `Status` varchar(30) NOT NULL default '',
  `TransactionID` varchar(30) default NULL,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM;


#
# Table structure for table bpelengine
#

CREATE TABLE `bpelengine` (
  `id` int(11) NOT NULL auto_increment,
  `startTime` varchar(100) NOT NULL default '',
  `endTime` varchar(100) default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;


#
# Table structure for table bpelinstance
#

CREATE TABLE `bpelinstance` (
  `ID` int(11) NOT NULL auto_increment,
  `InstanceID` varchar(100) NOT NULL default '',
  `Type` varchar(30) NOT NULL default '',
  `BeginTime` varchar(100) NOT NULL default '',
  `FinishTime` varchar(100) default '',
  `Status` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM;


#
# Table structure for table inferiortable
#

CREATE TABLE `inferiortable` (
  `txid` varchar(100) NOT NULL default '',
  `inferiorId` varchar(100) NOT NULL default '',
  `status` varchar(100) NOT NULL default '',
  `preparetime_b` bigint(20) default '0',
  `preparetime_e` bigint(20) default '0',
  `confirmtime_b` bigint(20) default '0',
  `confirmtime_e` bigint(20) default '0',
  `canceltime_b` bigint(20) default '0',
  `canceltime_e` bigint(20) default '0',
  PRIMARY KEY  (`inferiorId`)
) TYPE=MyISAM;


#
# Table structure for table superiortable
#

CREATE TABLE `superiortable` (
  `txid` varchar(100) NOT NULL default '',
  `starttime` varchar(100) default '',
  `stoptime` varchar(100) default '',
  `preparetime_b` bigint(20) default '0',
  `prepare_time_e` bigint(20) default '0',
  `confirmtime_b` bigint(20) default '0',
  `confirmtime_e` bigint(20) default '0',
  `canceltime_b` bigint(20) default '0',
  `result` varchar(100) NOT NULL default '',
  `canceltime_e` bigint(20) default '0',
  `status` varchar(100) NOT NULL default '',
  `deciderAddr` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`txid`)
) TYPE=MyISAM;

