
package org.act.services.runtime;
import org.act.metaset.Metaset;
import org.act.services.connector.IObjectPoolConnector;
import org.act.services.pool.IObjectPool;
import org.act.services.runtime.lifecycle.ILifecycle;
import org.act.services.thread.ThreadPool;

public interface IRuntime extends ILifecycle {
	public abstract IObjectPoolConnector getObjectPoolConnector(String name);
	public abstract void putObjectPoolConnector(IObjectPoolConnector connector);
	public abstract IObjectPoolConnector createPoolConnector(Metaset config);
	public abstract boolean createThreadPool(Metaset config);
	public abstract ThreadPool getThreadPool(String name);
	
	public abstract IObjectPool getObjectPool(String name, int mode);
	public abstract boolean createObjectPool(Metaset config);
	
	public String getWSDLLocation(String serviceName);
}
