
package org.act.services.transaction.messages;
import org.act.services.transaction.util.*;

public class TransactionTimelimit extends Qualifier{
	
    int seconds_ = -1;
    
    public TransactionTimelimit(int seconds)
    {
        super("btpq:transaction-timelimit");
        addElement(new XElement("btpq:timelimit", Integer.toString(seconds)));
        seconds_ = seconds;
    }
    
    public TransactionTimelimit(XElement el)
    {
        super(el);
        XElement tlim = elementAt(0);
        if (tlim != null)
        {
            try
            {
                seconds_ = Integer.parseInt(tlim.getValue());
            }
            catch (NumberFormatException ne)
            {
                seconds_ = -1;
            }
        }
    }
    
    public int getTimelimit()
    {
        return seconds_;
    }
    public static void main(String[] args)
    {
        TransactionTimelimit transactionTimelimit1 = new TransactionTimelimit(
            1000);
        System.out.println(transactionTimelimit1.toXml());
    }
}
