
package org.act.services.workflow.activity.structured;
import java.util.Stack;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.services.IMessageContext;
import org.act.services.pool.IObjectPool;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.expression.DateExpression;
import org.act.services.workflow.expression.DurationExpression;

public class PickImpl extends ActivityImpl {
	private IObjectPool msgIn;
	
	public void process() {
				super.process();
				Metaset onAlarms = activity.filter(".\\onAlarm");
		boolean hasonAlarm = false;
		if (onAlarms != null)
			hasonAlarm = true;
		String durationExpression = null;
		String dateExpression = null;
				if (hasonAlarm) {
			durationExpression = onAlarms.car().selector(".\\", "for");
			if (durationExpression == null)
				dateExpression = onAlarms.car().selector(".\\", "until");
						if ((durationExpression == null) && (dateExpression == null))
				System.err.println("onAlarm ĸʽ!");
		}
				Metaset onMessages = activity.filter(".\\onMessage");
		boolean hasGetonMessage = false;
		long timeBegin = System.currentTimeMillis();
				long runningTime = 0;
				while (onTime(hasonAlarm, durationExpression, dateExpression,
				runningTime)
				&& !hasGetonMessage) {
						for (int i = 0; i < onMessages.getChilds().size(); i++) {
								Metaset onMessage = (Metaset) onMessages.getChilds().get(i);
								String mPartnerLink = onMessage.selector(".\\", "partnerLink");
				String mPortType = onMessage.selector(".\\", "portType");
				String mOperation = onMessage.selector(".\\", "operation");
				String mVariable = onMessage.selector(".\\", "variable");
				Metaset mCorrelations = onMessage.filter(".\\correlations\\*");
								Metaset onMessageActivity = (Metaset) onMessage.getChilds()
						.get(1);
								Metaset partnerLink;
				partnerLink = this.rc.getWc().getPartnerLinks().filter(
						".\\partnerLink", "name", mPartnerLink);
												String mPartnerLinkType = partnerLink.selector(
						".\\partnerLink", "partnerLinkType");
				QName qname = new QName(mPartnerLinkType);
				String partnerLinkTypeName = qname.getName();
								String partnerRole = partnerLink.selector(".\\partnerLink",
						"partnerRole");
								Metaset wsdl = null;
				try {
					wsdl = (Metaset) this.rc.getWc().getWsdlOnPartnerLinkType(
							partnerLinkTypeName, partnerRole);
				} catch (Exception e) {
										e.printStackTrace();
				}
								Metaset correlations = new Metaset();
				if (mCorrelations != null) {
					for (int j = 0; j < mCorrelations.getChilds().size(); j++) {
						Metaset mCorrelationSet = (Metaset) mCorrelations
								.getChilds().get(j);
												String correlationSetName = mCorrelationSet.selector(
								".\\", "set");
												String initiate = mCorrelationSet.selector(".\\",
								"initiate");
																								if ((initiate == null) && (initiate.equals("no"))) {
							Metaset correlationSet = this.rc
									.getCorrelationSets()
									.getCorrelationSetOnName(correlationSetName);
							correlations.add(correlationSet);
						}
					}
				}
				
				Metaset values = null;
								IObjectPool pool = msgIn;
												values = this.recv(wsdl, mOperation, mPortType,
						mPartnerLink, correlations, pool, rc);
								if (values.isEmpty()) {
					continue;
				}
								else {
																									Metaset bodyvalue = null;
					bodyvalue = values.filter(".\\Body\\*");
					Metaset value = null;
					value = bodyvalue.car();
					
					for (int k = 0; k < value.getChilds().size(); k++) {
						this.rc.getVariables()
								.setVarPartValue(
										mVariable,
										k,
										((Metaset) value.getChilds().get(k))
												.getValue());
					}
					if (mCorrelations != null) {
												for (int m = 0; m < mCorrelations.getChilds().size(); m++) {
							Metaset mCorrelationSet = (Metaset) mCorrelations
									.getChilds().get(m);
														String correlationSetName = mCorrelationSet
									.selector(".\\", "set");
														String initiate = mCorrelationSet.selector(".\\",
									"initiate");
														if (initiate.equals("yes")) {
								this.rc.getCorrelationSets()
										.setCorrelationSetFromVar(
												correlationSetName, mVariable);
							}
						}
					}
										stack.push(onMessageActivity);
					hasGetonMessage = true;
										break;
				}
			}
			if (!hasGetonMessage) {
				try {
										Thread.sleep(50);
				} catch (InterruptedException e) {
										e.printStackTrace();
				}
			}
			long timeEnd = System.currentTimeMillis();
			runningTime = timeEnd - timeBegin;
		}
				if (!hasGetonMessage) {
			Metaset onAlarmActivity = onAlarms.car().car();
			stack.push(onAlarmActivity);
		}
	}
	
    	public Metaset recv(Metaset wsdl, String op, String portType,
			String parternerLink, Metaset cs, IObjectPool pool,
			WorkflowRuntimeContext rc) {
		Metaset result = new Metaset();
		while (result.isEmpty()) {
						synchronized (pool) {
				int poolSize = pool.size();
				for (int i = 0; i < poolSize; i++) {
					IMessageContext messageContext = (IMessageContext) pool
							.get(i);
					Metaset requestMessage = messageContext
							.getRequestServices();
					Metaset value = requestMessage.filter(".\\Body\\*");
					String requestOP = value.car().getName();
					
					if (messageContext.getServicesName().equals(
							rc.getWc().getName())) {
																														Metaset correlationSetsLocal = cs;
												Metaset correlationSetsRemote = new Metaset();
						if ((requestMessage
								.filter(".\\Header\\CorrelationSets")) != null) {
							correlationSetsRemote = requestMessage
									.filter(
											".\\Header\\CorrelationSets\\correlationSet")
									.car();
						}
												boolean isCorrelationAccord = this
								.isCorrelationSetAccord(correlationSetsRemote,
										correlationSetsLocal);
						if (isCorrelationAccord) {
							if (requestOP.equals(op)) {
								try {
									result = (Metaset) requestMessage.clone();
								} catch (CloneNotSupportedException e) {
									e.printStackTrace();
								}
																rc.getPartnerLinkMgCxtMap().put(parternerLink,
										messageContext);
								pool.remove(i);
								break;
							}
						}
					}
				}
				if (result.isEmpty()) {
					try {
						pool.wait();
					} catch (InterruptedException e) {
												e.printStackTrace();
					}
				}
			}
		}
		return result;
	}
	
	
	private boolean isCorrelationSetAccord(Metaset remote, Metaset local) {
								boolean accord = false;
				if ((remote.isEmpty()) && (local.isEmpty())) {
			accord = true;
		}
				if ((!remote.isEmpty()) && (!local.isEmpty())) {
						if (local.toXML().equals(remote.toXML())) {
				accord = true;
			}
		}
		return accord;
	}
	
	private boolean onTime(boolean hasonAlarm, String durationExpression,
			String dateExpression, long runningTime) {
		if (!hasonAlarm)
			return true;
		if (durationExpression != null) {
			if (runningTime < DurationExpression
					.getExpressionValue(durationExpression))
				return true;
			else
				return false;
		}
		if (dateExpression != null) {
			if (runningTime < DateExpression.getExpressionValue(dateExpression))
				return true;
			else
				return false;
		}
		return false;
	}
	
	public PickImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack,
			IObjectPool msgIn) {
		super(activity, rc, stack);
		this.msgIn = msgIn;
			}
}
