
package org.act.services.workflow.expression;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.apache.xpath.XPathAPI;
import org.apache.xpath.objects.XObject;
import org.w3c.dom.Document;

public class GeneralExpression {
	
	public static String getExpressionValue(String expression) throws Exception {
		Document doc = newDocument();
		XObject xobject = XPathAPI.eval(doc, expression);
		return xobject.str();
	}
	
	
	private static DocumentBuilder newBuilder(boolean validation)
			throws Exception {
		DocumentBuilderFactory domFactory = DocumentBuilderFactory
				.newInstance();
		domFactory.setValidating(validation);
		domFactory.setNamespaceAware(true);
		DocumentBuilder domBuilder = domFactory.newDocumentBuilder();
		return domBuilder;
	}
	
	private static Document newDocument() throws Exception {
		DocumentBuilder domBuilder = newBuilder(false);
		Document document = domBuilder.newDocument();
		return document;
	}
	
	public static void main(String[] args) {
		try {
			System.out.print(GeneralExpression.getExpressionValue("concat('ad','cd')"));
		} catch (Exception e) {
						e.printStackTrace();
		}
	}
}
