
package org.act.wsrf.resourceproperties;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.logging.Logger;
import org.act.metaset.QName;
import org.act.metaset.Metaset;
import org.act.metaset.utils.MetasetUtil;
public class ResourceContext {
   public static ArrayList resource = new ArrayList();
   public Resource resMap = null;
   
   public void add(Metaset re){
   		resource.add(re);
   }
   
   public Resource getResource(){
   		return this.resMap;
   }
   
   public void setResource(Resource res){
   		this.resMap = res;
   }
   
   public Metaset find(QName name){
   		if(resource.isEmpty()){
   			Logger log = Logger.getLogger("resource context is empty");
   		}
   		Iterator iter = resource.iterator();
   		while(iter.hasNext()){
   			Metaset set = (Metaset)iter.next();
   			if((set.getName().equals(name.getName()))&&(MetasetUtil.getActualNamespace(set,set.getNamespace()).equals(name.getNameSpace()))){
   				return set;
   			}
   		}
   		return null;
   }
   
   
   public String create(QName name,String[] value){
   		if(resource.size()==0){
   			Logger log = Logger.getLogger("resource context is empty");
   		}
   		Metaset resourceset = find(name);
   	   		if(resourceset!=null){
   			initialize(resourceset,value);
   			System.out.println(resourceset.toXML());
   			   			int idInt =name.getName().hashCode()+name.getNameSpace().hashCode()+value.hashCode();
   			String id = Integer.toString(idInt);
   			resMap.addResource(resourceset,id);
   			return id;
   		}
   		return null;
   }
   
   
   public static void initialize(Metaset set,String[] value){
   		if(set.getChilds().size()!=value.length){
   			Logger log = Logger.getLogger("the value is mismatch");
   		}
   		int i=0;
   		Iterator iter = set.getChilds().iterator();
   		while(iter.hasNext()){
   			Metaset element = (Metaset)iter.next();
   			element.setValue(value[i]);
   			if(i<value.length-1){
   				i+=1;
   			}
   		}
   }
}
