package org.act.services.protocol;
import org.act.services.IAdaptable;
import org.act.services.IConfigurable;
import org.act.services.runtime.lifecycle.ALifecycle;

public abstract class Protocol extends ALifecycle implements IAdaptable, IConfigurable{
	
	
	private boolean running;
	private ProtocolDescriptor descriptor;
	private boolean enabled;
	public Protocol() {
	}
	
	public boolean isRunning() {
		return running;
	}
	
	protected void setRunning(boolean running) {
		this.running = running;
	}
	
	
	
	public ProtocolDescriptor getDescriptor() {
		return descriptor;
	}
	
	public void setDescriptor(ProtocolDescriptor descriptor) {
		this.descriptor = descriptor;
	}
	public boolean isEnabled() {
		return enabled;
	}
	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}
}
