
package org.act.services.wsdd;
import java.util.ArrayList;
import java.util.List;
import org.act.services.provider.Provider;

public class DeployContext {
	
	private List handlers = null;
	private Provider provider = null;
	private ClassLoader classLoader = null;
	private String wsarLocation = null;
		private String wsdlLocation=null;
		
	public DeployContext() {
	}
	
	
	
	public ClassLoader getClassLoader() {
		return classLoader;
	}
	
	
	public void setClassLoader(ClassLoader classLoader) {
		this.classLoader = classLoader;
	}
	
	
	public List getHandlers() {
		if (handlers==null) {
			handlers = new ArrayList(7);
		}
		return handlers;
	}
	
	
	public void setHandlers(List handlers) {
		this.handlers = handlers;
	}
	
	
	public Provider getProvider() {
		return provider;
	}
	
	
	public void setProvider(Provider provider) {
		this.provider = provider;
	}
	
	
	public String getWsarLocation() {
		return wsarLocation;
	}
	
	
	public void setWsarLocation(String wsarLocation) {
		this.wsarLocation = wsarLocation;
	}
		
	public String getWsdlLocation() {
		return wsdlLocation;
	}
	
	public void setWsdlLocation(String wsdlLocation) {
		this.wsdlLocation = wsdlLocation;
	}
	
	}
