
package org.act.services.wsdl.model;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ServicesMethod {
	
				public static final int RPC = 0;
	public static final int DOCUMENT = 1;
	
		private String name;
	
		private int processStyle = RPC;
	
		private List parameters;
	
		private ServicesType returnType;
	
		private List faults;
	
		private Class implementationClass;
	
	
	
	public ServicesMethod(String name) {
		this.name = name;
	}
	
	public String getName() {
		return this.name;
	}
	
	public List getParameters() {
		if (parameters==null) {
			parameters = new ArrayList();
		}
		return parameters;
	}
	
	public ServicesType getReturnType() {
		return returnType;
	}
	
	public void setReturnType(ServicesType type) {
		this.returnType = type;
	}
	
	
	
	public int getProcessStyle() {
		return processStyle;
	}
	
	
	public void setProcessStyle(int processStyle) {
		this.processStyle = processStyle;
	}
	
	public List getFaults() {
		if (faults==null) {
			faults = new ArrayList();
		}
		return faults;
	}	
	
	
	public Class getImplementationClass() {
		return implementationClass;
	}
	
	public void setImplementationClass(Class class1) {
		implementationClass = class1;
	}
	
	public String toString() {
		try {
		StringBuffer sb = new StringBuffer();
		sb.append(returnType.toString() + " " + name + "(" );
		
		for (Iterator iter = parameters.iterator(); iter.hasNext();) {
			ServicesType element = (ServicesType) iter.next();
			sb.append(element.toString()+",");
		}
		if (parameters.size()>0) {
			sb.deleteCharAt(sb.length()-1);
		}
		sb.append(")");
		return sb.toString();
		}
		catch(Exception e) {}
		return super.toString();
	}
}
