
package org.act.services.wsdl.model;

public class ServicesType {
	private String namespace;
	private String name;
	
	
	
	public ServicesType(String namespace, String name) {
		this.namespace = namespace;
		this.name = name;
	}
	
	
	
	public String getName() {
		return name;
	}
	
	
	public void setName(String name) {
		this.name = name;
	}
	
	
	public String getNamespace() {
		return namespace;
	}
	
	
	public void setNamespace(String namespace) {
		this.namespace = namespace;
	}
	
	
	
	public boolean equals(Object obj) {
		if (obj==this) {
			return true;
		}
		if (! (obj instanceof ServicesType)) {
			return false;
		}
		ServicesType type = (ServicesType)obj;
		return name.equals(type.name) && namespace.equals(type.namespace);
	}
	
	
	public int hashCode() {
		return name.hashCode() + namespace.hashCode();
	}
	
	
	public String toString() {
		return "{"+namespace + "}:" + name;
	}
}
