
package org.act.services.transaction.util;

public class XName {
	
    String nspace = null;
    
    String name = null;
    
    public XName(String name)
    {
        int pos = name.indexOf(':');
        if (pos >= 0)
        {
            nspace = name.substring(0, pos);
            this.name = name.substring(pos + 1);
        }
        else
        {
            this.name = name;
        }
    }
    
    public XName(String ns, String name)
    {
        this.nspace = ns;
        this.name = name;
    }
    
    public String getName()
    {
        return this.name;
    }
    
    public String getNamespace()
    {
        return this.nspace;
    }
    
    public String toString()
    {
        return (nspace != null ? nspace + ":" : "") + name;
    }
    public static void main(String[] args)
    {
        XName XName1 = new XName("space", "name");
        System.out.print(XName1.toString());
    }
	
}
