package org.act.services.protocol;
import org.act.services.pool.IObjectPool;
import org.act.services.thread.ThreadPool;

public abstract class TransportProtocol extends Protocol {
    
    private ThreadPool threadPool;
    
    private IObjectPool transportInputPool;
    
    public void setThreadPool(ThreadPool threadPool) {
        this.threadPool = threadPool;
    }
    
    public void setTransportInputPool(IObjectPool pool) {
        this.transportInputPool = pool;
    }
    
    protected ThreadPool getThreadPool() {
        return threadPool;
    }
    
    protected IObjectPool getTransportInputPool() {
        return transportInputPool;
    }
}
