
package org.act.services.workflow.activity.basic;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.expression.DateExpression;
import org.act.services.workflow.expression.DurationExpression;

public class WaitImpl extends ActivityImpl {
	
	public void process() {
				super.process();
	
		boolean isDuration = true;
		String durationExpression = null;
		String dateExpression = null;
		
		durationExpression = activity.selector(".\\","for");
		dateExpression = activity.selector(".\\", "until");
		
		if(durationExpression == null)
			isDuration = false;
		
		long waitingTime = 0;
		if (isDuration) {
			waitingTime = DurationExpression
					.getExpressionValue(durationExpression);
				
		}else {
			waitingTime = DateExpression.getExpressionValue(dateExpression);
		}
		try {
			Thread.sleep(waitingTime);
		} catch (InterruptedException e) {
						e.printStackTrace();
		}
	}
	
	public WaitImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack) {
		super(activity, rc, stack);
			}
}
