
package org.act.services.workflow.activity.scope;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class CompensateImpl extends ActivityImpl {
	
							public void process() {
				super.process();
		
		String scope = this.activity.selector(".\\", "scope");
		Stack localKeepStack = this.rc.getLocalKeepStack();
		Metaset compensationHandler = null;
				if (scope == null || scope.equals(this.rc.getScopeName())) {
			Metaset handler = this.rc.getCompensationHandler();
						if (handler != null) {
				compensationHandler = handler;
			}
									else {
				for (int i = localKeepStack.size() - 5; i > 0; i = i - 6) {
					handler = (Metaset) localKeepStack.get(i);
					if (handler != null) {
						compensationHandler = handler;
						break;
					}
				}
			}
		}
				else {
						for (int i = localKeepStack.size() - 1; i > 0; i = i - 6) {
				String scopeName = (String) localKeepStack.get(i);
				if (scope.equals(scopeName)) {
															for (int j = i - 4; j > 0; j = j - 6) {
						Metaset handler = (Metaset) localKeepStack
								.get(j);
						if (handler != null) {
							compensationHandler = handler;
							break;
						}
					}
				}
			}
		}
		if (compensationHandler != null) {
			this.stack.push(compensationHandler.car());
			return;
		}
	}
	
	public CompensateImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack) {
		super(activity, rc, stack);
			}
}
