
package org.act.services.workflow.activity.scope;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;

public class ScopeImpl extends ActivityImpl {
	
	
	public void process() {
				super.process();
				rc.saveLocale();
		Metaset variablesSet = activity.filter("scope\\variables");
		Metaset variables = null;
				if (variablesSet != null) {
			variables = variablesSet.car();
			rc.getVariables().setVars(variables);
		}
		activity.remove(".\\variables");
		Metaset correlationSets = activity.filter("scope\\correlationSets");
		if (correlationSets != null) {
			if (!correlationSets.isEmpty()) {
				rc.getCorrelationSets().setCSs(correlationSets.car());
			}
		}
		Metaset faultHandlers = activity.filter("scope\\faultHandlers");
		if (faultHandlers != null) {
			if (!faultHandlers.isEmpty()) {
				rc.setFaultHandlers(faultHandlers.car());
			}
		}
		Metaset compensationHandler = activity
				.filter("scope\\compensationHandler");
		if (compensationHandler != null) {
			if (!compensationHandler.isEmpty()) {
				rc.setCompensationHandler(compensationHandler.car());
			}
		}
		Metaset eventHandlers = activity.filter("scope\\eventHandlers");
		if (eventHandlers != null) {
			if (!eventHandlers.isEmpty()) {
				rc.setEventHandlers(eventHandlers.car());
			}
		}
								Metaset scopeOver = new Metaset("scopeOver");
		Metaset empty = new Metaset("empty");
		scopeOver.add(empty);
				Metaset subActivities = activity.filter("scope\\*");
		rc.getActivitiesStack().push(scopeOver);
		for (int i = subActivities.getChilds().size() - 1; i >= 0; i--) {
			Metaset sub = (Metaset) subActivities.getChilds().get(i);
			rc.getActivitiesStack().push(sub);
		}
	}
	
	public ScopeImpl(Metaset activity, WorkflowRuntimeContext rc, Stack stack) {
		super(activity, rc, stack);
			}
}
