
package org.act.services.workflow.activity.structured;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.expression.BooleanExpression;

public class SwitchImpl extends ActivityImpl {
	
	
	public void process() {
				super.process();
		String condition;
		Metaset activityCases = activity.filter("switch\\case");
		Metaset activityOtherwise = activity.filter("switch\\otherwise");
		Metaset activityCase = null;
		boolean accordWith = false;
				while (!activityCases.isEmpty()) {
			activityCase = activityCases.car();
			condition = activityCase.selector("case", "condition");
			try {
				if (BooleanExpression.getExpressionValue(condition,this.rc)) {
					accordWith = true;
					break;
				}
			} catch (Exception e) {
								e.printStackTrace();
			}
			activityCases.cdr();
		}
				if (accordWith) {
			if (activityCase != null) {
				Metaset subActivity = activityCase.filter(".\\*");
								for (int i = subActivity.getChilds().size() - 1; i >= 0; i--) {
					stack.push(subActivity.getChilds().get(i));
				}
			}
		}
				else {
			if (activityOtherwise != null) {
				Metaset subActivity = activityOtherwise.filter(".\\*");
								for (int i = subActivity.getChilds().size() - 1; i >= 0; i--) {
					stack.push(subActivity.getChilds().get(i));
				}
			}
		}
	}
	
	public SwitchImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack) {
		super(activity, rc, stack);
			}
}
