
package org.act.services.workflow.activity.structured;
import java.util.Stack;
import org.act.metaset.Metaset;
import org.act.services.workflow.activity.ActivityImpl;
import org.act.services.workflow.context.WorkflowRuntimeContext;
import org.act.services.workflow.expression.BooleanExpression;

public class WhileImpl extends ActivityImpl {
	
	public void process() {
				super.process();
		String condition = activity.selector(".\\", "condition");
		try {
			
			if (BooleanExpression.getExpressionValue(condition,this.rc))
			{
				Metaset subActivity = activity.filter("while\\*");
				stack.push(activity);
				for (int i = subActivity.getChilds().size() - 1; i >= 0; i--) {
					stack.push(subActivity.getChilds().get(i));
				}
			}
		} catch (Exception e) {
						e.printStackTrace();
		}
	}
	
	public WhileImpl(Metaset activity, WorkflowRuntimeContext rc,
			Stack stack) {
		super(activity, rc, stack);
			}
}
