
package org.act.services.workflow.management;
import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FilterOutputStream;
import java.io.IOException;

public class ConfigInfo {
    public static String getConfigFile()
    {
    	String text="";
    	String dir=System.getProperty("user.dir")
			+ java.io.File.separator
			+ "conf"
			+ java.io.File.separator
			+ "server.conf";
    	
				
		try {
			File userConfigFile = new File(dir);
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(userConfigFile)));
			ByteArrayOutputStream outputstrem = new ByteArrayOutputStream();
			int nNumber = 0;
			byte[] buffer = new byte[4096];
			while ((nNumber = input.read(buffer)) != -1) {
				outputstrem.write(buffer, 0, nNumber);
			}
			input.close();
			text = new String(outputstrem.toByteArray());
			
			text=text.trim();
			System.out.println(text);
		} catch (FileNotFoundException e) {
								} catch (IOException e) {
								}
		
    	return text;
    	
    }
    public static String setConfigFile(String text)
    {
    	File configFile = null;
		String dir = System.getProperty("user.dir") + java.io.File.separator
				+ "conf" + java.io.File.separator + "server.conf";
		try {
			configFile = new File(dir);
			FilterOutputStream output = new FilterOutputStream(
					new FileOutputStream(configFile));
			output.write(text.getBytes());
			output.close();
		} catch (FileNotFoundException e) {
									return "fail";
		} catch (IOException e) {
									return "fail";
		}
		return "success";
    	
    }
}
