package org.act.services.workflow.management;
import org.act.services.workflow.runtime.WSWFRuntime;


public class ObjectPoolInfo {
	
	public static final int IN_MODE = 0;
	
	public static final int OUT_MODE = 1;
	
	
	public static final String FAIL="FAIL";
	
	public static final String SUC="SUCCESS";
	
	
	public String getObjectPoolSize(String name,String mode)
	{
		String result="FAIL";
		if (mode.equalsIgnoreCase("in"))
			result=String.valueOf(WSWFRuntime.getRuntime().getObjectPool(name,IN_MODE).size());
		else if (mode.equalsIgnoreCase("out"))
			result= String.valueOf(WSWFRuntime.getRuntime().getObjectPool(name,OUT_MODE).size());
		return result;
	}
	
	
	public String getObjectPoolMaxSize(String name,String mode)
	{
		String result="FAIL";
				if (mode.equalsIgnoreCase("in"))
			result=String.valueOf(WSWFRuntime.getRuntime().getObjectPool(name,IN_MODE).getMaxSize());
		else if (mode.equalsIgnoreCase("out"))
			result= String.valueOf(WSWFRuntime.getRuntime().getObjectPool(name,OUT_MODE).getMaxSize());
		return result;
	}
	
	
	public String setObjectPoolMaxSize(String name,String mode,int maxSize)
	{
		String result="SUC";
		try
		{
			if (mode.equalsIgnoreCase("in"))
				WSWFRuntime.getRuntime().getObjectPool(name,IN_MODE).setMaxSize(maxSize);
			else if (mode.equalsIgnoreCase("out"))
				WSWFRuntime.getRuntime().getObjectPool(name,OUT_MODE).setMaxSize(maxSize);
		}
		catch (Exception ex)
		{
			result=String.valueOf(ex.toString());
		}
		return result;
	}
	
	
	public String getAllObjectPoolName()
	{
		return""; 	}
}
