
package org.act.services.workflow.management;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.metaset.QName;
import org.act.services.IAttachment;
import org.act.services.IMessageContext;
import org.act.services.workflow.deploy.DeployManager;

public class SystemInfoWrapper {
	private SystemInfo instance = new SystemInfo();
	public static final String DEPLOY_DIR = "org.act.services.deployDir";
		public Metaset getJVMFreeM(Metaset message) {
		List childs = message.filter("Envelope\\Body\\*\\*").getChilds();
								int unitnum = Integer.parseInt(((Metaset) childs.get(0)).getValue());
				String result = instance.getJVMFreeM(unitnum);
		try {
			Metaset response = new Metaset("soapenv", "Envelope");
			response.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));			response.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset res = new Metaset("getJVMFreeMResponse");
			Metaset returnSS = new Metaset("getJVMFreeMReturn"); 			returnSS.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			returnSS.setValue(result);
			res.add(returnSS);
			body.add(res);
			response.add(body);
			return response;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
	}
	public Metaset getJVMMaxM(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		int tmp0 = Integer.parseInt(((Metaset) parameters.get(0)).getValue());
		String result = instance.getJVMMaxM(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getJVMMaxMResponse");
			Metaset ret = new Metaset("getJVMMaxMReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getJVMTotalM(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		int tmp0 = Integer.parseInt(((Metaset) parameters.get(0)).getValue());
		String result = instance.getJVMTotalM(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getJVMTotalMResponse");
			Metaset ret = new Metaset("getJVMTotalMReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
		public Metaset getExpriyTime(Metaset message) {
				String result = instance.getExpriyTime();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getExpriyTimeResponse");
			Metaset ret = new Metaset("getExpriyTimeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setExpiryTime(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.setExpiryTime(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setExpiryTimeResponse");
			Metaset ret = new Metaset("setExpiryTimeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getReplyPatternValueRespone(Metaset message) {
				boolean result = instance.getReplyPatternValueRespone();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset(
					"getReplyPatternValueResponeResponse");
			Metaset ret = new Metaset("getReplyPatternValueResponeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setReplyPatternValueResponse(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setReplyPatternValueResponse(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset(
					"setReplyPatternValueResponseResponse");
			Metaset ret = new Metaset("setReplyPatternValueResponseReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getReplyPatternValueCallback(Metaset message) {
				boolean result = instance.getReplyPatternValueCallback();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset(
					"getReplyPatternValueCallbackResponse");
			Metaset ret = new Metaset("getReplyPatternValueCallbackReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setReplyPatternValueCallback(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setReplyPatternValueCallback(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset(
					"setReplyPatternValueCallbackResponse");
			Metaset ret = new Metaset("setReplyPatternValueCallbackReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getReplyPatternValuePoll(Metaset message) {
				boolean result = instance.getReplyPatternValuePoll();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getReplyPatternValuePollResponse");
			Metaset ret = new Metaset("getReplyPatternValuePollReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setReplyPatternValuePoll(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setReplyPatternValuePoll(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setReplyPatternValuePollResponse");
			Metaset ret = new Metaset("setReplyPatternValuePollReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getGroupExpiryTime(Metaset message) {
				String result = instance.getGroupExpiryTime();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getGroupExpiryTimeResponse");
			Metaset ret = new Metaset("getGroupExpiryTimeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setGroupExpiryTime(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.setGroupExpiryTime(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setGroupExpiryTimeResponse");
			Metaset ret = new Metaset("setGroupExpiryTimeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getGroupMaxIdleDuration(Metaset message) {
				int result = instance.getGroupMaxIdleDuration();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getGroupMaxIdleDurationResponse");
			Metaset ret = new Metaset("getGroupMaxIdleDurationReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setGroupMaxIdleDuration(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		int tmp0 = Integer.parseInt(((Metaset) parameters.get(0)).getValue());
		String result = instance.setGroupMaxIdleDuration(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setGroupMaxIdleDurationResponse");
			Metaset ret = new Metaset("setGroupMaxIdleDurationReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getGuaranteedDelivery(Metaset message) {
				boolean result = instance.getGuaranteedDelivery();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getGuaranteedDeliveryResponse");
			Metaset ret = new Metaset("getGuaranteedDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setGuaranteedDelivery(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setGuaranteedDelivery(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setGuaranteedDeliveryResponse");
			Metaset ret = new Metaset("setGuaranteedDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getNoDuplicateDelivery(Metaset message) {
				boolean result = instance.getNoDuplicateDelivery();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getNoDuplicateDeliveryResponse");
			Metaset ret = new Metaset("getNoDuplicateDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setNoDuplicateDelivery(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setNoDuplicateDelivery(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setNoDuplicateDeliveryResponse");
			Metaset ret = new Metaset("setNoDuplicateDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getExactlOnceDelivery(Metaset message) {
				boolean result = instance.getExactlOnceDelivery();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getExactlOnceDeliveryResponse");
			Metaset ret = new Metaset("getExactlOnceDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setExactlOnceDelivery(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setExactlOnceDelivery(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setExactlOnceDeliveryResponse");
			Metaset ret = new Metaset("setExactlOnceDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getOrderedDelivery(Metaset message) {
				boolean result = instance.getOrderedDelivery();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getOrderedDeliveryResponse");
			Metaset ret = new Metaset("getOrderedDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:boolean"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setOrderedDelivery(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		boolean tmp0 = (((Metaset) parameters.get(0)) != null)
				&& (((Metaset) parameters.get(0)).getValue()
						.equalsIgnoreCase("true"));
		String result = instance.setOrderedDelivery(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setOrderedDeliveryResponse");
			Metaset ret = new Metaset("setOrderedDeliveryReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getMaxCacheCapacity(Metaset message) {
				int result = SystemInfo.getMaxCacheCapacity();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getMaxCacheCapacityResponse");
			Metaset ret = new Metaset("getMaxCacheCapacityReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setMaxCacheCapacity(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		int tmp0 = Integer.parseInt(((Metaset) parameters.get(0)).getValue());
		String result = SystemInfo.setMaxCacheCapacity(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setMaxCacheCapacityResponse");
			Metaset ret = new Metaset("setMaxCacheCapacityReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getRmpState(Metaset message) {
				int result = SystemInfo.getRmpState();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getRmpStateResponse");
			Metaset ret = new Metaset("getRmpStateReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setRmpState(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		int tmp0 = Integer.parseInt(((Metaset) parameters.get(0)).getValue());
		String result = SystemInfo.setRmpState(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setRmpStateResponse");
			Metaset ret = new Metaset("setRmpStateReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getRMPCacheNum(Metaset message) {
								String result = SystemInfo.getRMPCacheNum();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getRMPCacheNumResponse");
			Metaset ret = new Metaset("getRMPCacheNumReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
		public Metaset getObjectPoolSize(Metaset message) {
		List childs = message.filter("Envelope\\Body\\*\\*").getChilds();
				String name = ((Metaset) childs.get(0)).getValue();
				String mode = ((Metaset) childs.get(1)).getValue();
				String result = instance.getObjectPoolSize(name, mode);
		try {
			Metaset response = new Metaset("soapenv", "Envelope");
			response.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));			response.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset res = new Metaset("getObjectPoolSizeResponse");
			Metaset returnSS = new Metaset("getObjectPoolSizeReturn"); 			returnSS.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			returnSS.setValue(result);
			res.add(returnSS);
			body.add(res);
			response.add(body);
			return response;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
	}
	public Metaset getObjectPoolMaxSize(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		String result = instance.getObjectPoolMaxSize(tmp0, tmp1);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getObjectPoolMaxSizeResponse");
			Metaset ret = new Metaset("getObjectPoolMaxSizeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setObjectPoolMaxSize(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		int tmp2 = Integer.parseInt(((Metaset) parameters.get(2)).getValue());
		String result = instance.setObjectPoolMaxSize(tmp0, tmp1, tmp2);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setObjectPoolMaxSizeResponse");
			Metaset ret = new Metaset("setObjectPoolMaxSizeReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getAllObjectPoolName(Metaset message) {
		String result = instance.getAllObjectPoolName();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getAllObjectPoolNameResponse");
			Metaset ret = new Metaset("getAllObjectPoolNameReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
		public Metaset getTPCurrentTreadCount(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getTPCurrentTreadCount(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTPCurrentTreadCountResponse");
			Metaset ret = new Metaset("getTPCurrentTreadCountReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTPCurrentTreadBusy(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getTPCurrentTreadBusy(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTPCurrentTreadBusyResponse");
			Metaset ret = new Metaset("getTPCurrentTreadBusyReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTPMaxSpareThread(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getTPMaxSpareThread(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTPMaxSpareThreadResponse");
			Metaset ret = new Metaset("getTPMaxSpareThreadReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTPMinSpareThread(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getTPMinSpareThread(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTPMinSpareThreadResponse");
			Metaset ret = new Metaset("getTPMinSpareThreadReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTPMaxThread(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getTPMaxThread(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTPMaxThreadResponse");
			Metaset ret = new Metaset("getTPMaxThreadReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getAllTPName(Metaset message) {
		String result = instance.getAllTPName();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getAllTPNameResponse");
			Metaset ret = new Metaset("getAllTPNameReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
		public Metaset getTxIdList(Metaset message) {
				String result = SystemInfo.getTxIdList();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTxIdListResponse");
			Metaset ret = new Metaset("getTxIdListReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTxStatus(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = SystemInfo.getTxStatus(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTxStatusResponse");
			Metaset ret = new Metaset("getTxStatusReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getRunningTxNumber(Metaset message) {
				int result = SystemInfo.getRunningTxNumber();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getRunningTxNumberResponse");
			Metaset ret = new Metaset("getRunningTxNumberReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getInferiorList(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = SystemInfo.getInferiorList(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getInferiorListResponse");
			Metaset ret = new Metaset("getInferiorListReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getInferiorInfo(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String tmp1 = ((Metaset) parameters.get(1)).getValue();
		String result = SystemInfo.getInferiorInfo(tmp0, tmp1);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getInferiorInfoResponse");
			Metaset ret = new Metaset("getInferiorInfoReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getConfirmTxNum(Metaset message) {
		int result = SystemInfo.getConfirmTxNum();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getConfirmTxNumResponse");
			Metaset ret = new Metaset("getConfirmTxNumReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getCancelTxNum(Metaset message) {
		int result = SystemInfo.getCancelTxNum();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getCancelTxNumResponse");
			Metaset ret = new Metaset("getCancelTxNumReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTimeOutTxNum(Metaset message) {
		int result = SystemInfo.getTimeOutTxNum();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTimeOutTxNumResponse");
			Metaset ret = new Metaset("getTimeOutTxNumReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:int"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
		public Metaset UnDeployInstance(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = SystemInfo.UnDeployInstance(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("UnDeployInstanceResponse");
			Metaset ret = new Metaset("UnDeployInstanceReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getDeployedInstances(Metaset message) {
		String result = SystemInfo.getDeployedInstances();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getDeployedInstancesResponse");
			Metaset ret = new Metaset("getDeployedInstancesReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getBpel(Metaset message) {
		List childs = message.filter("Envelope\\Body\\*\\*").getChilds();
				String name = ((Metaset) childs.get(0)).getValue();
								String result = SystemInfo.getBpel(name);
		try {
			Metaset response = new Metaset("soapenv", "Envelope");
			response.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));			response.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset res = new Metaset("getBpelResponse");
			Metaset returnSS = new Metaset("getBpelReturn"); 			returnSS.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			returnSS.setValue(result);
			res.add(returnSS);
			body.add(res);
			response.add(body);
			return response;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
	}
	public Metaset getWFWsdd(Metaset message) {
		List childs = message.filter("Envelope\\Body\\*\\*").getChilds();
				String name = ((Metaset) childs.get(0)).getValue();
								String result = SystemInfo.getWFWsdd(name);
		try {
			Metaset response = new Metaset("soapenv", "Envelope");
			response.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			response.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			response.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			response.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));			response.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset res = new Metaset("getWFWsddResponse");
			Metaset returnSS = new Metaset("getWFWsddReturn"); 			returnSS.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			returnSS.setValue(result);
			res.add(returnSS);
			body.add(res);
			response.add(body);
			return response;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return null;
	}
	public Metaset getActiveInstance(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getActiveInstance(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getActiveInstanceResponse");
			Metaset ret = new Metaset("getActiveInstanceReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getActivity(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.getActivity(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getActivityResponse");
			Metaset ret = new Metaset("getActivityReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getConfigFile(Metaset message) {
		String result = instance.getConfigFile();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getConfigFileResponse");
			Metaset ret = new Metaset("getConfigFileReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset setConfigFile(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = instance.setConfigFile(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("setConfigFileResponse");
			Metaset ret = new Metaset("setConfigFileReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getDeciderList(Metaset message) {
		String result = SystemInfo.getDeciderList();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getDeciderListResponse");
			Metaset ret = new Metaset("getDeciderListReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTransactionInfo(Metaset message) {
		List parameters = message.filter("Envelope\\Body\\*\\*").getChilds();
		String tmp0 = ((Metaset) parameters.get(0)).getValue();
		String result = SystemInfo.getTransactionInfo(tmp0);
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTransactionInfoResponse");
			Metaset ret = new Metaset("getTransactionInfoReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public Metaset getTxStatisticInfo(Metaset message) {
				String result = SystemInfo.getTxStatisticInfo();
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("getTxStatisticInfoResponse");
			Metaset ret = new Metaset("getTxStatisticInfoReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("" + result);
			response.add(ret);
			body.add(response);
			env.add(body);
			return env;
		} catch (Exception e) {
		}
		return null;
	}
	public void WorkflowUpload(IMessageContext mc) {
		IAttachment[] attachget = mc.getRequestAttachments();
		try {
			String processName = new String(attachget[0].getAttachment());
						String dir = System.getProperty(DEPLOY_DIR)
					+ java.io.File.separator + processName + ".bar";
			FileOutputStream out = new FileOutputStream(dir);
			out.write(attachget[1].getAttachment());
			out.flush();
			out.close();
			DeployManager.deploy_normal(processName);
		} catch (FileNotFoundException e) {
						e.printStackTrace();
		} catch (IOException e) {
						e.printStackTrace();
		}
		try {
			Metaset env = new Metaset("soapenv", "Envelope");
			env.add(new Attribute(new QName("xmlns", "soapenv"),
					"http://schemas.xmlsoap.org/soap/envelope/"));
			env.add(new Attribute(new QName("xmlns", "xsi"),
					"http://www.w3.org/2001/XMLSchema-instance"));
			env.add(new Attribute(new QName("xmlns", "xsd"),
					"http://www.w3.org/2001/XMLSchema"));
			env.add(new Attribute(new QName("xmlns", "soapenc"),
					"http://schemas.xmlsoap.org/soap/encoding/"));
			env.add(new Metaset("soapenv", "Header"));
			Metaset body = new Metaset("soapenv", "Body");
			Metaset response = new Metaset("WorkflowUploadResponse");
			Metaset ret = new Metaset("WorkflowUploadReturn");
			ret.add(new Attribute(new QName("xsi", "type"), "xsd:string"));
			ret.setValue("ok");
			response.add(ret);
			body.add(response);
			env.add(body);
			mc.setResponseServices(env);
					} catch (Exception e) {
		}
	}
}
