
package org.act.wsrf.basefaults;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

public final class BaseFaultUtil {
	
	
	
	public final static String s12  = "http://www.w3.org/2003/05/soap-envelope";
	public final static String xsd  = "http://www.w3.org/2001/XMLSchema";
	public final static String xsi  = "http://www.w3.org/2001/XMLSchema-instance";
	public final static String wsbf = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-BaseFaults-1.2-draft-02.xsd";
	public final static String wsa  = "http://schemas.xmlsoap.org/ws/2003/02/addressing";
	
	 
	
		public static final Date stringParseDate(String s) {
				Date result = new Date();
		SimpleDateFormat SDF = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss-HH:mm");
	    SDF.setTimeZone(TimeZone.getTimeZone("GMT"));
	    try {
	    	result = SDF.parse(s);
	    }
	    catch (ParseException ex) {
	    	ex.printStackTrace();
	    }
	    return result;
	}
	
		public static final int stringParseInteger(String s) {
				int duration = 0;
		try {
			duration = Integer.parseInt(s);
		}
		catch ( NumberFormatException ex) {
			ex.printStackTrace();
		}
		return duration;
	}	
	
		public static final long stringParseLong(String s) {
				long number = 0L;
		try {
			number = Long.parseLong(s);
		}
		catch ( NumberFormatException ex) {
			ex.printStackTrace();
		}
		return number;
	}	
}
